Page MenuHomeFreeBSD

rework libGL/libEGL/libGLESv2/nvidia-driver/xorg-server mess
ClosedPublic

Authored by kwm on Sep 10 2016, 1:15 PM.

Details

Summary

This is a first shot at simplifying the current situation. Please add comments
where needed.

  • Revert libGL/libEGL/libGLESv2 to just install there files in the normal places.
  • Rename the nvidia libraries and use libmap.conf(5) LOCALBASE support to point to them.

While libmap.conf(5) doesn't mentions support for port installed config files
in LOCALBASE, bapt was so nice of of mentioning it again. Since 9.2-R is no longer
supported all supported releases have this new functionality.

Dragonfly obviously doesn't ship nvidia-driver's so we don't have to see if they
support this libmap extension.

TODO/discussion:

  • The nvidia-driver code was "bolted on" so it probably needs some moving/cleaning up.
  • As far as my looking into xorg-server goes, it dlopen(3)'s the libglx.so library so I don't see any other way then what we currently use. As I understand it, libmap.conf(5) is part of the rtld(1) which doesn't come into effect with dlopen(3).
  • While we tinkering with these ports lets sort out the conflict with linux-c6-dri and nvidia-drivers ports. Though I think we need to use the old hardlink approuch here since the linux compat stuff doesn't know about libmap.conf(5) correct?

Diff Detail

Repository
rP FreeBSD ports repository
Lint
Automatic diff as part of commit; lint not applicable.
Unit
Automatic diff as part of commit; unit tests not applicable.

Event Timeline

kwm updated this revision to Diff 20242.Sep 10 2016, 1:15 PM
kwm retitled this revision from to rework libGL/libEGL/libGLESv2/nvidia-driver/xorg-server mess.
kwm updated this object.
kwm edited the test plan for this revision. (Show Details)
kwm added reviewers: bapt, danfe.
mat added a comment.Sep 13 2016, 12:14 PM

I think the proxydeps thing in Mk/Scripts/qa.sh will also need fixing.

bapt added inline comments.Sep 13 2016, 7:08 PM
x11/nvidia-driver/files/nvidia.conf.in
10 ↗(On Diff #20242)

%%NVGL%% will be expanded to @command here you want #

kwm added a comment.Sep 13 2016, 8:39 PM

@mat So you probably mean the gl-related parts, but I don't see what you thinking about what should be changed?

@bapt thanks, I updated it localy while I work on improving the patch.

bapt edited edge metadata.Oct 4 2016, 6:57 AM

sounds like reached the timeout

bapt added a comment.Oct 4 2016, 6:58 AM

except my comment hasn't been addressed :)

mat added a comment.Oct 4 2016, 7:22 AM

my comment was not either.

danfe edited edge metadata.Oct 4 2016, 8:24 AM

I didn't have a chance to properly review the proposal yet and make my thoughts of it. I'd like to ask for timeout period (whatever it is) to be expended, thank you.

kwm updated this revision to Diff 21064.Oct 5 2016, 1:29 PM
kwm edited edge metadata.

Fix comment replace in nvidia-driver.
Add libGL.so handling of nvidia-driver and linux-c6-dri.

kwm added a comment.Oct 5 2016, 1:31 PM

@mat If I understand your comment correctly it about updating the USE_XORG suggestions by qa.sh, I will open another review when I handle all the lib depends from USE_XORG.

mat added a comment.Oct 5 2016, 1:34 PM
In D7848#169050, @kwm wrote:

@mat If I understand your comment correctly it about updating the USE_XORG suggestions by qa.sh, I will open another review when I handle all the lib depends from USE_XORG.

I'm talking about the subst_dep_file function of Mk/Scripts/qa.sh, it was doing something related to GL, that something will either have to be fixed or removed.
I would prefer for it to happen here, so that it all gets committed at once.

kwm updated this revision to Diff 21066.Oct 5 2016, 1:39 PM

Drop subst_dep_file() from the qa.sh script. The libGL and libEGL ports
don't do wierd things anymore.

kwm added a comment.Oct 22 2016, 11:31 AM

ping, are we paste the timeout again?

mat accepted this revision.Oct 22 2016, 1:11 PM
mat added a reviewer: mat.
In D7848#173210, @kwm wrote:

ping, are we paste the timeout again?

Yes, we have.

This revision is now accepted and ready to land.Oct 22 2016, 1:11 PM
bapt added a comment.Nov 6 2016, 4:32 PM

Can we go ahead with that one? it has been there for more than 2 month already!

This needs to be resynced against ports updates. I can do so if desired.

kwm updated this revision to Diff 24799.Feb 6 2017, 2:23 PM
kwm edited edge metadata.
  • Sync with new ports tree.
  • Drop handling of linux-c[67]-dri <-> nvidia-driver conflict. tijl@ already committed a fix for it.
  • Clean up nvidia-driver Makefile
This revision now requires review to proceed.Feb 6 2017, 2:23 PM
This revision was automatically updated to reflect the committed changes.